Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.functions
Class VendorFunctionLibrary

    java.lang.Object
      net.sf.saxon.functions.VendorFunctionLibrary

All Implemented Interfaces:
  Serializable, FunctionLibrary

Direct Known Subclasses:
  ExtraFunctionLibrary

    public class VendorFunctionLibrary

extends Object
implements FunctionLibrary

The VendorFunctionLibrary represents specially-recognized functions in the Saxon namespace. It doesn't handle Saxon extension functions that are implemented as normal extension functions, which are bound using the `JavaExtensionLibrary`.

See Also:
  Serialized Form

Constructor Summary
`VendorFunctionLibrary()`

Method Summary
`Expression` | `bind(int nameCode, String uri, String local, Expression[] staticArgs)` Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
`FunctionLibrary` | `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
`boolean` | `isAvailable(int fingerprint, String uri, String local, int arity)` Test whether a Saxon function with a given name and arity is available.
`Expression` | `makeSaxonFunction(String localName, StaticContext env, Expression[] arguments)` Make a Saxon function with a given name
`static String` | `pluralArguments(int num)` Utility routine used in constructing error messages

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### VendorFunctionLibrary

    public VendorFunctionLibrary()

Method Detail

### isAvailable

    public boolean isAvailable(int fingerprint,
                               String uri,
                               String local,
                               int arity)

  Test whether a Saxon function with a given name and arity is available. This supports the function-available() function in XSLT. This method may be called either at compile time or at run time.

  Specified by:
    `isAvailable` in interface `FunctionLibrary`
  Parameters:
    `uri` - The URI of the function name
    `local` - The local part of the function name
    `arity` - The number of arguments. This is set to -1 in the case of the single-argument function-available() function; in this case the method should return true if there is some matching extension function, regardless of its arity.
    `fingerprint` - The namepool fingerprint of the function name. This must match the uri and localName; the information is provided redundantly to avoid repeated lookups in the name pool.

### bind

    public Expression bind(int nameCode,
                           String uri,
                           String local,
                           Expression[] staticArgs)
                    throws XPathException

  Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.

  Specified by:
    `bind` in interface `FunctionLibrary`
  Parameters:
    `uri` - The URI of the function name
    `local` - The local part of the function name
    `staticArgs` - The expressions supplied statically in the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality() may be used as part of the binding algorithm.
    `nameCode` - The namepool nameCode of the function name. The uri and local name are also supplied (redundantly) to avoid fetching them from the name pool.
  Returns:
    An object representing the extension function to be called, if one is found; null if no extension function was found matching the required name and arity.
  Throws:
    `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function; or if this function library "owns" the namespace containing the function call, but no function was found.

### makeSaxonFunction

    public Expression makeSaxonFunction(String localName,
                                        StaticContext env,
                                        Expression[] arguments)
                                 throws XPathException

  Make a Saxon function with a given name

  Throws:
    `XPathException`

### pluralArguments

    public static String pluralArguments(int num)

  Utility routine used in constructing error messages

### copy

    public FunctionLibrary copy()

  This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.

  Specified by:
    `copy` in interface `FunctionLibrary`
  Returns:
    a copy of this function library. This must be an instance of the original class.

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.